/* LIST IMPLEMENTATION - file list.c */
#include <stdio.h>
#include <stdlib.h>
#include "list.h"

/* OPERAZIONI PRIMITIVE */
list  emptylist(void)		/* costruttore lista vuota */
{ return NULL; }

boolean  empty(list l)	/* verifica se lista vuota */
{ return (l==NULL); }

list  cons(element e, list l)
{ list t;       /* costruttore che aggiunge in testa alla lista */
  t=(list)malloc(sizeof(item));
  t->value=e;
  t->next=l;
  return(t);
}

element  head(list l) /* selettore testa lista */
{ if (empty(l)) abort();
  else return (l->value); 
}

list  tail(list l)         /* selettore coda lista */
{ if (empty(l)) abort();
  else return (l->next); 
}



/* OPERAZIONI NON PRIMITIVE */


/*  ATTENZIONE:  la showlist() e' definita solo per element di tipo int  */
/* VERSIONE ITERATIVA: */
/*
void   showlist(list l)
{ 
  printf("[");
  while (!empty(l)) 
          { printf("%d",head(l));
	      l=tail(l);
	      if (!empty(l)) printf(", "); 
          }
  printf("]\n");
}
*/


/* Lunghezza di una lista (ricorsiva) */
/*
int	length(list l)
{ if (empty(l)) return(0);
  else return 1+length(tail(l));
}
*/


/* Lunghezza di una lista (iterativa) */
/*
int	length_it(list l)
{ int n=0;
  while (!empty(l))
	 { n++; 
          l=tail(l); }
  return(n);
}
*/


/* appartenenenza di un elemento - ricorsiva  */
/*
boolean member(element el, list l)
{ if (empty(l)) return 0;
  else { if (el==head(l)) return 1;
	  else return member(el,tail(l)); }
}
*/


/* appartenenenza di un elemento - iterativa  */
/*
boolean member_it(element el,list l)
{ while (!empty(l))
	  { if (el==head(l)) return 1;
           else  l= tail(l); }
  return 0;
}
*/


/* crea una copia della lista l */
/*
list copy (list l)
{ if (empty(l)) return l;
  else return cons(head(l),copy(tail(l)));
}
*/


/*
list delete(element el, list l)
{ if (empty(l)) return emptylist();
  else {if (el==head(l)) return tail(l);
	 else return cons(head(l),delete(el,tail(l))); }
}
*/


/* concatenamento di liste - ricorsiva */
/*
list append (list l1, list l2)
{
 if (empty(l1)) return l2;
  else return cons(head(l1),append(tail(l1),l2));
}
*/


 /* inversione di una lista - ricorsiva */
/*
list reverse (list l)
{
  if (empty(l)) return emptylist();
  else return append(reverse(tail(l)),
			cons(head(l),emptylist()));
}
*/


/* funzione ausiliaria */
/*
list rev(list l2, list l1)
{
 if  (empty(l1)) return l2;
 else return rev(cons(head(l1),l2),tail(l1)); 
}
*/


/* inversione di una lista - tail ricorsiva      */
/*
list reverse_tail(list l)
{
  return rev(emptylist(),l);
}
*/


/*  ATTENZIONE:  la insord() e' definita solo per element di tipo int*/
/*
list insord(element el, list l) {
  if (empty(l)) return cons(el,l);
  else if (el <= head(l)) return cons(el,l);
  else return cons(head(l), insord(el,tail(l)));
}
*/