#include "patient.h"
#include "readField.h"



int readCF(char buffer[], char sep, FILE *f)
{
    int i = 0;
    char ch = fgetc(f);
    while (ch != sep && ch != 10 && ch != EOF)
    {
        buffer[i++] = ch;
        ch = fgetc(f);
    }
	if (i<DIM_CF)
		buffer[i] = '\0';
    return i;
}

void printCF(char buffer[])
{
	int i;
	for (i=0; i<DIM_CF && buffer[i]!='\0'; i++)
		printf("%c", buffer[i]);
	return;
}


char readPatient(patient * thePatient, FILE * f)
{
	char ch;

	readCF(thePatient->cf, ' ', f);
	readField(thePatient->cognome, '@', f);
	readField(thePatient->nome, '@', f);
	ch = readField(thePatient->fileFatture, '@', f);
	return ch;
}


list readPatientList(char * filename)
{
	FILE * f;
	list result;
	patient temp;
	char endFile;

	result = emptylist();
	if ((f=fopen(filename, "r")) != NULL)
	{
		do {
			endFile = readPatient(&temp, f);
			result = cons(temp, result);
		} while( endFile != EOF);
	}
	fclose(f);
	return result;
}


int compareCF(char cf1[DIM_CF], char cf2[DIM_CF])
{
	int i;
	int equal = 1;

	for(i=0; i<DIM_CF && equal && cf1[i]!='\0' && cf2[i]!='\0'; i++)
	{
		if(cf1[i]!=cf2[i])
		{
			equal = 0;
		}
	}
	return equal;
}


//void destroyPatientList(list patientList);